# Class DialogWebElement

The component WebElement for oj-c-dialog. Do not instantiate this class directly, instead, use findDialog.

#### Hierarchy

- DialogWebElementBase
  - DialogWebElement

#####
Index

### Constructors

constructor

### Methods

clear
click
doClose
findElement
findElements
getAnchor
getAttribute
getCancelBehavior
getCssValue
getDialogTitle
getDragAffordance
getDriver
getHeaderDecoration
getHeight
getId
getLauncher
getLocation
getMaxHeight
getMaxWidth
getMinHeight
getMinWidth
getModality
getOffset
getOpened
getPlacement
getProperty
getRect
getResizeBehavior
getShadowRoot
getSize
getTagName
getText
getWidth
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new DialogWebElement(el, locators): DialogWebElement

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns DialogWebElement

  Inherited from DialogWebElementBase.constructor

## Methods

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from DialogWebElementBase.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from DialogWebElementBase.click

### doClose

- doClose(): Promise<void>

- Dismisses the dialog.

  #### Returns Promise<void>

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  Overrides DialogWebElementBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  Overrides DialogWebElementBase.findElements

### getAnchor

- getAnchor(): Promise<string | object>

- Gets the value of `anchor` property. Specifies Dialog's anchor. Dialog is placed relative to its anchor. If not specified, it is placed relative to window.

  #### Returns Promise<string | object>

  The value of `anchor` property.

  Inherited from DialogWebElementBase.getAnchor

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from DialogWebElementBase.getAttribute

### getCancelBehavior

- getCancelBehavior(): Promise<string>

- Gets the value of `cancelBehavior` property. Specifies the cancel behavior of the Dialog. Note that the cancelBehavior applies to both automatic and user-defined headers.

  #### Returns Promise<string>

  The value of `cancelBehavior` property.

  Inherited from DialogWebElementBase.getCancelBehavior

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from DialogWebElementBase.getCssValue

### getDialogTitle

- getDialogTitle(): Promise<string>

- Gets the value of `dialogTitle` property. Specifies title if header slot is not defined (custom header).

  #### Returns Promise<string>

  The value of `dialogTitle` property.

  Inherited from DialogWebElementBase.getDialogTitle

### getDragAffordance

- getDragAffordance(): Promise<string>

- Gets the value of `dragAffordance` property. Specifies whether the Dialog is draggable.

  #### Returns Promise<string>

  The value of `dragAffordance` property.

  Inherited from DialogWebElementBase.getDragAffordance

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from DialogWebElementBase.getDriver

### getHeaderDecoration

- getHeaderDecoration(): Promise<string>

- Gets the value of `headerDecoration` property. Specifies whether decorative stripe at the top is present.

  #### Returns Promise<string>

  The value of `headerDecoration` property.

  Inherited from DialogWebElementBase.getHeaderDecoration

### getHeight

- getHeight(): Promise<string | number>

- Gets the value of `height` property. Specifies height of the Dialog.

  #### Returns Promise<string | number>

  The value of `height` property.

  Inherited from DialogWebElementBase.getHeight

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from DialogWebElementBase.getId

### getLauncher

- getLauncher(): Promise<string>

- Gets the value of `launcher` property. Specifies Dialog's launcher. After Dialog closes, it returns focus to the launcher.

  #### Returns Promise<string>

  The value of `launcher` property.

  Inherited from DialogWebElementBase.getLauncher

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from DialogWebElementBase.getLocation

### getMaxHeight

- getMaxHeight(): Promise<string | number>

- Gets the value of `maxHeight` property. Specifies maxHeight of the Dialog.

  #### Returns Promise<string | number>

  The value of `maxHeight` property.

  Inherited from DialogWebElementBase.getMaxHeight

### getMaxWidth

- getMaxWidth(): Promise<string | number>

- Gets the value of `maxWidth` property. Specifies maxWidth of the Dialog.

  #### Returns Promise<string | number>

  The value of `maxWidth` property.

  Inherited from DialogWebElementBase.getMaxWidth

### getMinHeight

- getMinHeight(): Promise<string | number>

- Gets the value of `minHeight` property. Specifies minHeight of the Dialog.

  #### Returns Promise<string | number>

  The value of `minHeight` property.

  Inherited from DialogWebElementBase.getMinHeight

### getMinWidth

- getMinWidth(): Promise<string | number>

- Gets the value of `minWidth` property. Specifies minWidth of the Dialog.

  #### Returns Promise<string | number>

  The value of `minWidth` property.

  Inherited from DialogWebElementBase.getMinWidth

### getModality

- getModality(): Promise<string>

- Gets the value of `modality` property. Specifies modality of the Dialog.

  #### Returns Promise<string>

  The value of `modality` property.

  Inherited from DialogWebElementBase.getModality

### getOffset

- getOffset(): Promise<number | object>

- Gets the value of `offset` property. Specifies displacement of the Dialog from the anchor element placement along the specified axes. The offset object consists of mainAxis and crossAxis properties. The direction in which these propertie are applied depends on the current value of the position property. If a number is used, it represents the main axis. The <code>mainAxis</code> property represents the distance between the Popup and the anchor. The <code>crossAxis</code> property represents the deviation in the opposite axis to the main axis - the skidding between the Popup and the anchor.

  #### Returns Promise<number | object>

  The value of `offset` property.

  Inherited from DialogWebElementBase.getOffset

### getOpened

- getOpened(): Promise<boolean>

- Gets the value of `opened` property. Specifies whether the Dialog is open.

  #### Returns Promise<boolean>

  The value of `opened` property.

  Inherited from DialogWebElementBase.getOpened

### getPlacement

- getPlacement(): Promise<string>

- Gets the value of `placement` property. Specifies the location the dialog will appear relative to another element. If not specified, the default dialog position is "center" on desktop and "bottom-start" on phone.

  #### Returns Promise<string>

  The value of `placement` property.

  Inherited from DialogWebElementBase.getPlacement

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from DialogWebElementBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  Overrides DialogWebElementBase.getRect

### getResizeBehavior

- getResizeBehavior(): Promise<string>

- Gets the value of `resizeBehavior` property. Specifies whether the Dialog is resizable.

  #### Returns Promise<string>

  The value of `resizeBehavior` property.

  Inherited from DialogWebElementBase.getResizeBehavior

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from DialogWebElementBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  Overrides DialogWebElementBase.getSize

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from DialogWebElementBase.getTagName

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  Overrides DialogWebElementBase.getText

### getWidth

- getWidth(): Promise<string | number>

- Gets the value of `width` property. Specifies width of the Dialog.

  #### Returns Promise<string | number>

  The value of `width` property.

  Inherited from DialogWebElementBase.getWidth

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from DialogWebElementBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from DialogWebElementBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  Overrides DialogWebElementBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from DialogWebElementBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from DialogWebElementBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from DialogWebElementBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from DialogWebElementBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from DialogWebElementBase.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from DialogWebElementBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from DialogWebElementBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from DialogWebElementBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from DialogWebElementBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from DialogWebElementBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from DialogWebElementBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  #### Throws

  if the object is not a valid encoded ID.

  Inherited from DialogWebElementBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from DialogWebElementBase.isId

Generated using TypeDoc